#include"dos.h"
#include"conio.h"

#define MAXITERS 63
#define INFINITY 30000

/* O.K. here's what's different form the last:
     There is now a setpal function to set the
   grayscale palette.
*/

void initmode(int);
void setpal(unsigned char, unsigned char, unsigned char, unsigned char);

void main(void)
{
  double a,b,zx,zy,rx,ry;
  int c,q,d,e;
  initmode(0x13);
  for(d=0; d<255; d++)       /* set up palette */
    setpal(d-1,d/4,d/4,d/4);
  for(d=0; d<319; d++)
    for(e=0; e<199; e++)
    {
      a=(double)(d-200)/80;  /* set up real part of c */
      b=(double)(e-100)/50;  /* set up imaginary part of c */
      c=0;
      q=0;
      zx=0;
      zy=0;
      while(c<MAXITERS && q==0)
      {
	rx=zx*zx-zy*zy+a;    /* real part of z*z+c */
	ry=2*zx*zy+b;        /* imaginary part of z*z+c */
	zx=rx;               /* feed it back in */
	zy=ry;
	c++;                 /* increment iteration counter */
	if(rx>INFINITY || ry>INFINITY) q=1;
      }
      if(c>=MAXITERS) c=0;    /* did it go to infinity? If so, make it black */
      if(c!=0) pokeb(0xa000,d+e*320,c*4);
    }
  while(!kbhit());
  initmode(3);
}

void initmode(int mode)
{
  union REGS regs;
  regs.x.ax=mode;
  int86(0x10,&regs,&regs);
}

void setpal(unsigned char c,unsigned char r, unsigned char g, unsigned char b)
{
  outportb(0x3c7,c);
  outportb(0x3c9,r);
  outportb(0x3c9,g);
  outportb(0x3c9,b);
}